// Code generated by gowrap. DO NOT EDIT.
// template: ../../../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package service

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/collaborators -i Collaborators -t ../../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/pkg/collaborators"
	"go.uber.org/zap"
)

// recoveringMiddleware implements collaborators.Collaborators that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   collaborators.Collaborators
}

// RecoveringMiddleware instruments an implementation of the collaborators.Collaborators with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next collaborators.Collaborators) collaborators.Collaborators {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) Get(ctx context.Context, spaceId string, subject string) (role string, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Get(ctx, spaceId, subject)
}

func (m *recoveringMiddleware) ListCollaborators(ctx context.Context, spaceId string) (collaborators []*collaborators.Collaborator, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.ListCollaborators(ctx, spaceId)
}

func (m *recoveringMiddleware) ListSpaces(ctx context.Context, subject string) (spaces []*collaborators.Collaborator, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.ListSpaces(ctx, subject)
}

func (m *recoveringMiddleware) Remove(ctx context.Context, spaceId string, subject string) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Remove(ctx, spaceId, subject)
}

func (m *recoveringMiddleware) Set(ctx context.Context, spaceId string, subject string, role string) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Set(ctx, spaceId, subject, role)
}
